vertex{
	
	void main(){
		gl_Position = ftransform();
	}
	
};

fragment{
	uniform float x;
	uniform float y;
	uniform sampler2D tex;

	void main(){
		vec2 texCoord = gl_FragCoord.xy / vec2(x, y);
		
		vec4 addColor = vec4(0, 0, 0, 1);
		
//		Middle
		addColor += texture2D(tex, vec2(texCoord.x, texCoord.y)) * 0.046153;
		
//		Inner ring
		addColor += texture2D(tex, vec2(texCoord.x-(1.0/x), texCoord.y)) * 0.038461;
		addColor += texture2D(tex, vec2(texCoord.x, texCoord.y)-(1.0/y)) * 0.038461;
		addColor += texture2D(tex, vec2(texCoord.x, texCoord.y)+(1.0/y)) * 0.038461;
		addColor += texture2D(tex, vec2(texCoord.x+(1.0/x), texCoord.y)) * 0.038461;
		
//		Second inner ring
		addColor += texture2D(tex, vec2(texCoord.x-(1.0/x), texCoord.y+(1.0/y))) * 0.030769;
		addColor += texture2D(tex, vec2(texCoord.x+(1.0/x), texCoord.y+(1.0/y))) * 0.030769;
		addColor += texture2D(tex, vec2(texCoord.x+(1.0/x), texCoord.y-(1.0/y))) * 0.030769;
		addColor += texture2D(tex, vec2(texCoord.x-(1.0/x), texCoord.y-(1.0/y))) * 0.030769;
		
//		Medium inner ring
		addColor += texture2D(tex, vec2(texCoord.x+(2.0/x), texCoord.y-(1.0/y))) * 0.023076;
		addColor += texture2D(tex, vec2(texCoord.x+(2.0/x), texCoord.y+(1.0/y))) * 0.023076;
		addColor += texture2D(tex, vec2(texCoord.x+(2.0/x), texCoord.y)) * 0.023076;
		
		addColor += texture2D(tex, vec2(texCoord.x-(2.0/x), texCoord.y-(1.0/y))) * 0.023076;
		addColor += texture2D(tex, vec2(texCoord.x-(2.0/x), texCoord.y+(1.0/y))) * 0.023076;
		addColor += texture2D(tex, vec2(texCoord.x-(2.0/x), texCoord.y)) * 0.023076;
		
		addColor += texture2D(tex, vec2(texCoord.x-(1.0/y), texCoord.y+(2.0/x))) * 0.023076;
		addColor += texture2D(tex, vec2(texCoord.x+(1.0/y), texCoord.y+(2.0/x))) * 0.023076;
		addColor += texture2D(tex, vec2(texCoord.x, texCoord.y+(2.0/x))) * 0.023076;
		
		addColor += texture2D(tex, vec2(texCoord.x-(1.0/y), texCoord.y-(2.0/x))) * 0.023076;
		addColor += texture2D(tex, vec2(texCoord.x+(1.0/y), texCoord.y-(2.0/x))) * 0.023076;
		addColor += texture2D(tex, vec2(texCoord.x, texCoord.y-(2.0/x))) * 0.023076;
		
//		Second outer ring
		addColor += texture2D(tex, vec2(texCoord.x+(3.0/x), texCoord.y-(1.0/y))) * 0.015384;
		addColor += texture2D(tex, vec2(texCoord.x+(3.0/x), texCoord.y+(1.0/y))) * 0.015384;
		addColor += texture2D(tex, vec2(texCoord.x+(3.0/x), texCoord.y)) * 0.015384;
		
		addColor += texture2D(tex, vec2(texCoord.x+(2.0/x), texCoord.y+(2.0/y))) * 0.015384;
		
		addColor += texture2D(tex, vec2(texCoord.x-(3.0/x), texCoord.y-(1.0/y))) * 0.015384;
		addColor += texture2D(tex, vec2(texCoord.x-(3.0/x), texCoord.y+(1.0/y))) * 0.015384;
		addColor += texture2D(tex, vec2(texCoord.x-(3.0/x), texCoord.y)) * 0.015384;
		
		addColor += texture2D(tex, vec2(texCoord.x-(2.0/x), texCoord.y+(2.0/y))) * 0.015384;
		
		addColor += texture2D(tex, vec2(texCoord.x-(1.0/x), texCoord.y+(2.0/y))) * 0.015384;
		addColor += texture2D(tex, vec2(texCoord.x+(1.0/x), texCoord.y+(2.0/y))) * 0.015384;
		addColor += texture2D(tex, vec2(texCoord.x, texCoord.y+(2.0/y))) * 0.015384;
		
		addColor += texture2D(tex, vec2(texCoord.x-(2.0/x), texCoord.y-(2.0/y))) * 0.015384;
		
		addColor += texture2D(tex, vec2(texCoord.x-(1.0/x), texCoord.y-(2.0/y))) * 0.015384;
		addColor += texture2D(tex, vec2(texCoord.x+(1.0/x), texCoord.y-(2.0/y))) * 0.015384;
		addColor += texture2D(tex, vec2(texCoord.x, texCoord.y-(2.0/y))) * 0.015384;
		
		addColor += texture2D(tex, vec2(texCoord.x-(2.0/x), texCoord.y-(2.0/y))) * 0.015384;
		
//		Outer ring
		addColor += texture2D(tex, vec2(texCoord.x+(4.0/x), texCoord.y)-(1.0/y)) * 0.007692;
		addColor += texture2D(tex, vec2(texCoord.x+(4.0/x), texCoord.y)+(1.0/y)) * 0.007692;
		addColor += texture2D(tex, vec2(texCoord.x+(4.0/x), texCoord.y)) * 0.007692;
		
		addColor += texture2D(tex, vec2(texCoord.x-(4.0/x), texCoord.y)-(1.0/y)) * 0.007692;
		addColor += texture2D(tex, vec2(texCoord.x-(4.0/x), texCoord.y)+(1.0/y)) * 0.007692;
		addColor += texture2D(tex, vec2(texCoord.x-(4.0/x), texCoord.y)) * 0.007692;
		
		addColor += texture2D(tex, vec2(texCoord.x-(1.0/x), texCoord.y+(4.0/y))) * 0.007692;
		addColor += texture2D(tex, vec2(texCoord.x+(1.0/x), texCoord.y+(4.0/y))) * 0.007692;
		addColor += texture2D(tex, vec2(texCoord.x, texCoord.y+(4.0/y))) * 0.007692;
		
		addColor += texture2D(tex, vec2(texCoord.x-(1.0/x), texCoord.y-(4.0/y))) * 0.007692;
		addColor += texture2D(tex, vec2(texCoord.x+(1.0/x), texCoord.y-(4.0/y))) * 0.007692;
		addColor += texture2D(tex, vec2(texCoord.x, texCoord.y-(4.0/y))) * 0.007692;
		
		addColor += texture2D(tex, vec2(texCoord.x-(3.0/x), texCoord.y-(2.0/y))) * 0.007692;
		addColor += texture2D(tex, vec2(texCoord.x-(3.0/x), texCoord.y+(2.0/y))) * 0.007692;
		addColor += texture2D(tex, vec2(texCoord.x+(3.0/x), texCoord.y-(2.0/y))) * 0.007692;
		addColor += texture2D(tex, vec2(texCoord.x+(3.0/x), texCoord.y+(2.0/y))) * 0.007692;
		
		addColor += texture2D(tex, vec2(texCoord.x+(2.0/x), texCoord.y-(3.0/y))) * 0.007692;
		addColor += texture2D(tex, vec2(texCoord.x-(2.0/x), texCoord.y-(3.0/y))) * 0.007692;
		addColor += texture2D(tex, vec2(texCoord.x-(2.0/x), texCoord.y+(3.0/y))) * 0.007692;
		addColor += texture2D(tex, vec2(texCoord.x+(2.0/x), texCoord.y+(3.0/y))) * 0.007692;
		
		gl_FragColor = addColor;
	}

};