#This is an example shader for dynamic fonts
#This file does not include anti-aliasing for the font
#author Philip R

vertex{
	uniform int type;
	uniform int ns;
	uniform int ew;
	uniform int textLength;
	uniform int charI;
	uniform int charN;
	uniform int line;
	uniform int lastLineLength;
	uniform float charSpace;
	
	uniform float posSize[4];
	
	int modului(int arg0, int arg1){
		return (arg0-(arg1*(arg0/arg1)));
	}
	
	void main(){
		vec4 posFin = vec4(0.0, 0.0, 0.0, 1.0);
		
		if(ew == 0){
			posFin.x = posSize[0] - (((float(textLength)*posSize[2])+(float(textLength)*charSpace))/2.0);
		} else if(ew == 1){
			posFin.x = posSize[0];
		} else if(ew == 2){
			posFin.x = posSize[0] - ((float(textLength)*posSize[2])+(float(textLength)*charSpace));
		}
		
		if(ns == 0){
			posFin.y = posSize[1] - (posSize[3]/2.0);
		} else if(ns == 3){
			posFin.y = posSize[1] - posSize[3];
		} else if(ns == 4){
			posFin.y = posSize[1];
		}
		
		float newLineBack = ((float(lastLineLength) * posSize[2]) + (float(lastLineLength) * charSpace));
		float charX = (((float(charN) * posSize[2]) + (float(charN) * float(charSpace))) + (gl_Vertex.x*posSize[2])) - newLineBack;
		float charY = ((float(line) * posSize[3]) + float(charSpace)) + (gl_Vertex.y*posSize[3]);
		
		vec4 pos = vec4((posFin.x + charX), (posFin.y + charY), 0.0, 1.0);
		
		gl_TexCoord[0] = vec4(((0.0625*float(modului(charI, 16)))+(gl_Vertex.x*0.0625)), ((0.0625*float(charI / 16))+(gl_Vertex.y*0.0625)), 0.0, 0.0);
		gl_Position = gl_ModelViewProjectionMatrix * pos;
	}

};

fragment{
	
	uniform float color[4];
	
	uniform sampler2D tex;
	
	void main(){
		vec4 texColor = texture2D(tex, gl_TexCoord[0].xy);
		gl_FragColor = texColor * vec4(color[0], color[1], color[2], color[3]);
	}

};