vertex{
	attribute vec4 color;
	
	uniform int mapSize;
	
	varying vec4 fragColor;
	
	int modului(int arg0, int arg1){
		return (arg0-(arg1*(arg0/arg1)));
	}
	
	void main(){
		vec4 vertex = gl_Vertex;
		gl_Position = gl_ModelViewProjectionMatrix * vec4(vertex.xy, 0.0, 1.0);
		
		float x = float(modului(int(vertex.w), (mapSize*mapSize)));
		float y = float(int(vertex.w)/(mapSize*mapSize));
		float ms = 1.0/float(mapSize);
		
		if(vertex.z == 0.0){
			gl_TexCoord[0] = vec4(x*ms, y*ms, 0.0, 0.0);
		} else if(vertex.z == 1.0){
			gl_TexCoord[0] = vec4(x*ms+ms, y*ms, 0.0, 0.0);
		} else if(vertex.z == 2.0){
			gl_TexCoord[0] = vec4(x*ms+ms, y*ms+ms, 0.0, 0.0);
		} else if(vertex.z == 3.0){
			gl_TexCoord[0] = vec4(x*ms, y*ms+ms, 0.0, 0.0);
		}
		
		fragColor = color;
	}
	
};

fragment{
	uniform sampler2D particle_map;
	
	varying vec4 fragColor;
	
	void main(){
		vec4 mapColor = texture2D(particle_map, gl_TexCoord[0].xy);
		mapColor *= fragColor;
		gl_FragColor = mapColor;
	}
	
};